## rust-pathrs 0.2.1

=== Makefile ===
# SPDX-License-Identifier: MPL-2.0 OR LGPL-3.0-or-later
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 Aleksa Sarai <cyphar@cyphar.com>
# Copyright (C) 2019-2025 SUSE LLC
#
# == MPL-2.0 ==
#
#  This Source Code Form is subject to the terms of the Mozilla Public
#  License, v. 2.0. If a copy of the MPL was not distributed with this
#  file, You can obtain one at https://mozilla.org/MPL/2.0/.
#
# Alternatively, this Source Code Form may also (at your option) be used
# under the terms of the GNU Lesser General Public License Version 3, as
# described below:
#
# == LGPL-3.0-or-later ==
#
#  This program is free software: you can redistribute it and/or modify it
#  under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or (at
#  your option) any later version.
#
#  This program is distributed in the hope that it will be useful, but
#  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
#  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
#  for more details.
#
#  You should have received a copy of the GNU Lesser General Public License
#  along with this program. If not, see <https://www.gnu.org/licenses/>.

CARGO ?= cargo
CARGO_NIGHTLY ?= cargo +nightly

# Unfortunately --all-features needs to be put after the subcommand, but
# cargo-hack needs to be put before the subcommand. So make a function to make
# this a little easier.
ifneq (, $(shell which cargo-hack))
define cargo_hack
	$(1) hack --feature-powerset $(2)
endef
else
define cargo_hack
	$(1) $(2) --all-features
endef
endif
CARGO_CHECK := $(call cargo_hack,$(CARGO),check)
CARGO_CLIPPY := $(call cargo_hack,$(CARGO),clippy)
CARGO_LLVM_COV := $(call cargo_hack,$(CARGO_NIGHTLY),llvm-cov)

RUSTC_FLAGS := --features=capi -- -C panic=abort
CARGO_FLAGS ?=

SRC_FILES = $(wildcard Cargo.*) $(shell find . -name '*.rs')

.DEFAULT: debug
.PHONY: debug
debug: target/debug

target/debug: $(SRC_FILES)
	# For some reason, --crate-types needs separate invocations. We can't use
	# #![crate_type] unfortunately, as using it with #![cfg_attr] has been
	# deprecated. <https://github.com/rust-lang/rust/issues/91632>
	$(CARGO) rustc $(CARGO_FLAGS) --crate-type=cdylib    $(RUSTC_FLAGS)
	$(CARGO) rustc $(CARGO_FLAGS) --crate-type=staticlib $(RUSTC_FLAGS)

.PHONY: release
release: target/release

target/release: $(SRC_FILES)
	# For some reason, --crate-types needs separate invocations. We can't use
	# #![crate_type] unfortunately, as using it with #![cfg_attr] has been
	# deprecated. <https://github.com/rust-lang/rust/issues/91632>
	$(CARGO) rustc $(CARGO_FLAGS) --release --crate-type=cdylib    $(RUSTC_FLAGS)
	$(CARGO) rustc $(CARGO_FLAGS) --release --crate-type=staticlib $(RUSTC_FLAGS)

.PHONY: smoke-test
smoke-test:
	make -C examples smoke-test

.PHONY: clean
clean:
	-rm -rf target/

.PHONY: lint
lint: validate-cbindgen lint-rust

.PHONY: lint-rust
lint-rust:
	$(CARGO_NIGHTLY) fmt --all -- --check
	$(CARGO_CLIPPY) --all-targets
	$(CARGO_CHECK) $(CARGO_FLAGS) --all-targets

.PHONY: validate-cbindgen
validate-cbindgen:
	$(eval TMPDIR := $(shell mktemp --tmpdir -d libpathrs-cbindgen-check.XXXXXXXX))
	@																		\
		trap "rm -rf $(TMPDIR)" EXIT ;										\
		cbindgen -c cbindgen.toml -o $(TMPDIR)/pathrs.h ;					\
		if ! ( diff -u include/pathrs.h $(TMPDIR)/pathrs.h ); then			\
			echo -e															\
			  "\n"															\
			  "ERROR: include/pathrs.h is out of date.\n\n"					\
			  "Changes to the C API in src/capi/ usually need to be paired with\n" \
			  "an update to include/pathrs.h using cbindgen. To fix this error,\n" \
			  "just run:\n\n"												\
			  "\tcbindgen -c cbindgen.toml -o include/pathrs.h\n" ;			\
			exit 1 ;														\
		 fi

.PHONY: test-rust-doctest
test-rust-doctest:
	$(CARGO_LLVM_COV) --no-report --branch --doc

.PHONY: test-rust-unpriv
test-rust-unpriv:
	./hack/rust-tests.sh --cargo="$(CARGO_NIGHTLY)"
	./hack/rust-tests.sh --cargo="$(CARGO_NIGHTLY)" --enosys=openat2
	# In order to avoid re-running the entire test suite with just statx
	# disabled, we re-run the key procfs tests with statx disabled.
	./hack/rust-tests.sh --cargo="$(CARGO_NIGHTLY)" --enosys=statx "test(#tests::*procfs*)"

.PHONY: test-rust-root
test-rust-root:
	./hack/rust-tests.sh --cargo="$(CARGO_NIGHTLY)" --sudo
	./hack/rust-tests.sh --cargo="$(CARGO_NIGHTLY)" --sudo --enosys=openat2
	# In order to avoid re-running the entire test suite with just statx
	# disabled, we re-run the key procfs tests with statx disabled.
	./hack/rust-tests.sh --cargo="$(CARGO_NIGHTLY)" --sudo --enosys=statx "test(#tests::*procfs*)"

.PHONY: test-rust
test-rust:
	-rm -rf target/llvm-cov*
	make test-rust-{doctest,unpriv,root}

.PHONY: test-e2e
test-e2e:
	make -C e2e-tests test-all
	make -C e2e-tests RUN_AS=root test-all

.PHONY: test
test: test-rust test-e2e
	$(CARGO_NIGHTLY) llvm-cov report
	$(CARGO_NIGHTLY) llvm-cov report --open

.PHONY: docs
docs:
	$(CARGO) doc --all-features --document-private-items --open

.PHONY: install
install: release
	@echo "If you want to configure the install paths, use ./install.sh directly."
	@echo "[Sleeping for 3 seconds.]"
	@sleep 3s
	./install.sh

=== e2e-tests/Makefile ===
#!/bin/bash
# SPDX-License-Identifier: MPL-2.0
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 Aleksa Sarai <cyphar@cyphar.com>
# Copyright (C) 2019-2025 SUSE LLC
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at https://mozilla.org/MPL/2.0/.

ifneq ($(RUN_AS),)
	SUDO := sudo -u $(RUN_AS)
endif

BATS ?= bats

ALL_TESTS := $(patsubst cmd/%/Makefile,test-%,$(wildcard cmd/*/Makefile))

.DEFAULT: test-all
.PHONY: test-all
test-all: $(ALL_TESTS)

test-%: cmd/%/pathrs-cmd FORCE
	$(SUDO) PATHRS_CMD=$< $(BATS) -t tests/

cmd/%/pathrs-cmd: FORCE
	make -C $(@D) $(@F)

# .PHONY doesn't work with patterns so we need to create a dummy rule.
# See <https://www.gnu.org/software/make/manual/html_node/Force-Targets.html>
# and <https://www.gnu.org/software/make/manual/html_node/Phony-Targets.html>.
FORCE:

=== examples/Makefile ===
# SPDX-License-Identifier: MPL-2.0
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 Aleksa Sarai <cyphar@cyphar.com>
# Copyright (C) 2019-2025 SUSE LLC
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at https://mozilla.org/MPL/2.0/.


.PHONY: smoke-test
smoke-test:
	make -C c $@
	make -C go $@
	make -C python $@
	make smoke-test-rust

.PHONY: smoke-test-rust
smoke-test-rust:
	make -C rust-cat smoke-test

=== examples/c/Makefile ===
# SPDX-License-Identifier: MPL-2.0
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 Aleksa Sarai <cyphar@cyphar.com>
# Copyright (C) 2019-2025 SUSE LLC
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at https://mozilla.org/MPL/2.0/.


CC ?= gcc

CFLAGS := $(shell pkg-config --cflags pathrs)
LDFLAGS := $(shell pkg-config --libs-only-L --libs-only-other pathrs)
LDLIBS := $(shell pkg-config --libs-only-l pathrs)

.PHONY: all
all: $(patsubst %.c,%,$(wildcard *.c))

cat_multithread: LDLIBS += -lpthread

.PHONY: smoke-test
smoke-test: cat cat_multithread
	./cat . ../../cat.c >/dev/null
	./cat_multithread . ../../cat_multithread.c >/dev/null

=== examples/go/Makefile ===
# SPDX-License-Identifier: MPL-2.0
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 Aleksa Sarai <cyphar@cyphar.com>
# Copyright (C) 2019-2025 SUSE LLC
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at https://mozilla.org/MPL/2.0/.

GO ?= go

GOMOD_FILES := go.mod go.sum

%: %.go $(GOMOD_FILES)
	$(GO) build -o $@ $<

.PHONY: smoke-test
smoke-test: cat sysctl
	./cat . ../../cat.go &>/dev/null
	./sysctl kernel.hostname kernel.overflowuid kernel.overflowgid

=== examples/python/Makefile ===
# SPDX-License-Identifier: MPL-2.0
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 Aleksa Sarai <cyphar@cyphar.com>
# Copyright (C) 2019-2025 SUSE LLC
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at https://mozilla.org/MPL/2.0/.

.PHONY: smoke-test
smoke-test:
	./cat.py . ../../cat.py
	./sysctl.py kernel.hostname kernel.overflowuid kernel.overflowgid

=== examples/rust-cat/Makefile ===
# SPDX-License-Identifier: MPL-2.0
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 Aleksa Sarai <cyphar@cyphar.com>
# Copyright (C) 2019-2025 SUSE LLC
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at https://mozilla.org/MPL/2.0/.

CARGO ?= cargo

EXAMPLE_NAME := $(basename $(shell basename $$PWD))

.PHONY: build
build:
	$(CARGO) build --example $(EXAMPLE_NAME)

.PHONY: smoke-test
smoke-test: build
	../../target/debug/examples/$(EXAMPLE_NAME) . ../../main.rs &>/dev/null

=== contrib/bindings/python/Makefile ===
# SPDX-License-Identifier: MPL-2.0
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 Aleksa Sarai <cyphar@cyphar.com>
# Copyright (C) 2019-2025 SUSE LLC
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at https://mozilla.org/MPL/2.0/.

PYTHON ?= python3
PIP ?= pip3

SRC_FILES := $(wildcard *.py pathrs/*.py)

dist: $(SRC_FILES) pyproject.toml
	$(PYTHON) -m build

.PHONY: clean
clean:
	rm -rf dist/ pathrs.*-info/ pathrs/__pycache__/ pathrs/_libpathrs_cffi.*

.PHONY: lint
lint:
	ruff format --check --diff .
	ruff check .
	mypy .

.PHONY: install
install: dist
	$(PIP) install dist/pathrs*.whl

=== e2e-tests/cmd/go/Makefile ===
#!/bin/bash
# SPDX-License-Identifier: MPL-2.0
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 Aleksa Sarai <cyphar@cyphar.com>
# Copyright (C) 2019-2025 SUSE LLC
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at https://mozilla.org/MPL/2.0/.

pathrs-cmd: *.go go.*
	go build -o $@

=== e2e-tests/cmd/python/Makefile ===
#!/bin/bash
# SPDX-License-Identifier: MPL-2.0
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 Aleksa Sarai <cyphar@cyphar.com>
# Copyright (C) 2019-2025 SUSE LLC
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at https://mozilla.org/MPL/2.0/.

define script =
#!/bin/bash
# SPDX-License-Identifier: MPL-2.0
#
# libpathrs: safe path resolution on Linux
# Copyright (C) 2019-2025 Aleksa Sarai <cyphar@cyphar.com>
# Copyright (C) 2019-2025 SUSE LLC
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at https://mozilla.org/MPL/2.0/.

set -Eeuo pipefail

SRC_DIR="$(readlink -f "$(dirname "${BASH_SOURCE[0]}")")"

exec "$SRC_DIR/.venv/bin/python3" "$SRC_DIR/pathrs-cmd.py" "$@"
endef

.ONESHELL:

.PHONY: pathrs-cmd
pathrs-cmd: .venv
	cat >$@ <<'EOF'
	$(value script)
	EOF
	chmod +x $@

.PHONY: .venv
.venv:
	python3 -m venv $@
	make -C ../../../contrib/bindings/python
	$@/bin/pip3 install --force ../../../contrib/bindings/python/dist/*.whl

=== debian/changelog ===
rust-pathrs (0.2.1-1) unstable; urgency=medium

  * Package pathrs 0.2.1 from crates.io using debcargo 2.7.11

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 08 Nov 2025 16:20:08 -0500

=== debian/control ===
Source: rust-pathrs
Section: rust
Priority: optional
Build-Depends: debhelper-compat (= 13),
 dh-sequence-cargo
Build-Depends-Arch: cargo:native <!nocheck>,
 rustc:native (>= 1.63) <!nocheck>,
 libstd-rust-dev <!nocheck>,
 librust-bitflags-2+default-dev (>= 2.2-~~) <!nocheck>,
 librust-itertools-0.13+default-dev <!nocheck>,
 librust-libc-0.2+default-dev (>= 0.2.175-~~) <!nocheck>,
 librust-memchr-2+default-dev <!nocheck>,
 librust-once-cell-1+default-dev <!nocheck>,
 librust-rustix-1+default-dev (>= 1.1-~~) <!nocheck>,
 librust-rustix-1+fs-dev (>= 1.1-~~) <!nocheck>,
 librust-rustix-1+mount-dev (>= 1.1-~~) <!nocheck>,
 librust-rustix-1+process-dev (>= 1.1-~~) <!nocheck>,
 librust-rustix-1+thread-dev (>= 1.1-~~) <!nocheck>,
 librust-rustversion-1+default-dev <!nocheck>,
 librust-static-assertions-1+default-dev (>= 1.1-~~) <!nocheck>,
 librust-tempfile-3+default-dev <!nocheck>,
 librust-thiserror-2+default-dev <!nocheck>
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Reinhard Tartler <siretart@tauware.de>
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/rust-team/debcargo-conf.git [src/pathrs]
Vcs-Browser: https://salsa.debian.org/rust-team/debcargo-conf/tree/master/src/pathrs
Homepage: https://github.com/cyphar/libpathrs
X-Cargo-Crate: pathrs

Package: librust-pathrs-dev
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librust-bitflags-2+bytemuck-dev (>= 2.2-~~),
 librust-bitflags-2+default-dev (>= 2.2-~~),
 librust-bytemuck-1+default-dev,
 librust-bytemuck-1+derive-dev,
 librust-bytemuck-1+extern-crate-std-dev,
 librust-itertools-0.13+default-dev,
 librust-libc-0.2+default-dev (>= 0.2.175-~~),
 librust-memchr-2+default-dev,
 librust-once-cell-1+default-dev,
 librust-rand-0.8+default-dev,
 librust-rustix-1+default-dev (>= 1.1-~~),
 librust-rustix-1+fs-dev (>= 1.1-~~),
 librust-rustix-1+mount-dev (>= 1.1-~~),
 librust-rustix-1+process-dev (>= 1.1-~~),
 librust-rustix-1+thread-dev (>= 1.1-~~),
 librust-rustversion-1+default-dev,
 librust-static-assertions-1+default-dev (>= 1.1-~~),
 librust-tempfile-3+default-dev,
 librust-thiserror-2+default-dev
Provides:
 librust-pathrs+-test-as-root-dev (= ${binary:Version}),
 librust-pathrs+capi-dev (= ${binary:Version}),
 librust-pathrs+default-dev (= ${binary:Version}),
 librust-pathrs-0-dev (= ${binary:Version}),
 librust-pathrs-0+-test-as-root-dev (= ${binary:Version}),
 librust-pathrs-0+capi-dev (= ${binary:Version}),
 librust-pathrs-0+default-dev (= ${binary:Version}),
 librust-pathrs-0.2-dev (= ${binary:Version}),
 librust-pathrs-0.2+-test-as-root-dev (= ${binary:Version}),
 librust-pathrs-0.2+capi-dev (= ${binary:Version}),
 librust-pathrs-0.2+default-dev (= ${binary:Version}),
 librust-pathrs-0.2.1-dev (= ${binary:Version}),
 librust-pathrs-0.2.1+-test-as-root-dev (= ${binary:Version}),
 librust-pathrs-0.2.1+capi-dev (= ${binary:Version}),
 librust-pathrs-0.2.1+default-dev (= ${binary:Version})
Description: C-friendly API to make path resolution safer on Linux - Rust source code
 Source code for Debianized Rust crate "pathrs"

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem cargo
export RUSTC_BOOTSTRAP := 1
export PATH := $(CURDIR)/debian/debcargo_testing_bin:$(PATH)

=== debian/tests/control ===
Test-Command: /usr/share/cargo/bin/cargo-auto-test pathrs 0.2.1 --all-targets --all-features
Features: test-name=rust-pathrs:@
Depends: dh-cargo (>= 31), rustc (>= 1.63), librust-anyhow-1+default-dev, librust-clap-3+cargo-dev, librust-clap-3+default-dev, librust-errno-0.3+default-dev, librust-indoc-2+default-dev, librust-paste-1+default-dev, librust-path-clean-1+default-dev, librust-pretty-assertions-1+default-dev (>= 1.4.1-~~), librust-pretty-assertions-1+unstable-dev (>= 1.4.1-~~), librust-tempfile-3+default-dev, @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test pathrs 0.2.1 --all-targets --no-default-features --features _test_as_root
Features: test-name=librust-pathrs-dev:_test_as_root
Depends: dh-cargo (>= 31), rustc (>= 1.63), librust-anyhow-1+default-dev, librust-clap-3+cargo-dev, librust-clap-3+default-dev, librust-errno-0.3+default-dev, librust-indoc-2+default-dev, librust-paste-1+default-dev, librust-path-clean-1+default-dev, librust-pretty-assertions-1+default-dev (>= 1.4.1-~~), librust-pretty-assertions-1+unstable-dev (>= 1.4.1-~~), librust-tempfile-3+default-dev, @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test pathrs 0.2.1 --all-targets --no-default-features --features capi
Features: test-name=librust-pathrs-dev:capi
Depends: dh-cargo (>= 31), rustc (>= 1.63), librust-anyhow-1+default-dev, librust-clap-3+cargo-dev, librust-clap-3+default-dev, librust-errno-0.3+default-dev, librust-indoc-2+default-dev, librust-paste-1+default-dev, librust-path-clean-1+default-dev, librust-pretty-assertions-1+default-dev (>= 1.4.1-~~), librust-pretty-assertions-1+unstable-dev (>= 1.4.1-~~), librust-tempfile-3+default-dev, @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test pathrs 0.2.1 --all-targets
Features: test-name=librust-pathrs-dev:default
Depends: dh-cargo (>= 31), rustc (>= 1.63), librust-anyhow-1+default-dev, librust-clap-3+cargo-dev, librust-clap-3+default-dev, librust-errno-0.3+default-dev, librust-indoc-2+default-dev, librust-paste-1+default-dev, librust-path-clean-1+default-dev, librust-pretty-assertions-1+default-dev (>= 1.4.1-~~), librust-pretty-assertions-1+unstable-dev (>= 1.4.1-~~), librust-tempfile-3+default-dev, @
Restrictions: allow-stderr, skip-not-installable, flaky

Test-Command: /usr/share/cargo/bin/cargo-auto-test pathrs 0.2.1 --all-targets --no-default-features
Features: test-name=librust-pathrs-dev:
Depends: dh-cargo (>= 31), rustc (>= 1.63), librust-anyhow-1+default-dev, librust-clap-3+cargo-dev, librust-clap-3+default-dev, librust-errno-0.3+default-dev, librust-indoc-2+default-dev, librust-paste-1+default-dev, librust-path-clean-1+default-dev, librust-pretty-assertions-1+default-dev (>= 1.4.1-~~), librust-pretty-assertions-1+unstable-dev (>= 1.4.1-~~), librust-tempfile-3+default-dev, @
Restrictions: allow-stderr, skip-not-installable, flaky

=== debian/watch ===
Version: 5

Source: https://qa.debian.org/cgi-bin/fakeupstream.cgi?upstream=crates.io/pathrs
Matching-Pattern:  .*/crates/pathrs/@ANY_VERSION@/download
Filenamemangle: s/.*\/(.*)\/download/pathrs-$1\.tar\.gz/g
Uversionmangle: s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\.?\d*)$/$1~$2/
